!DIR$ FIXEDFORMLINESIZE:132
      subroutine CombSolver(bing,bsol,info)
      use blocks
      use index
      implicit none
      integer*4, intent(in)  :: bing(0:Nm1)
      integer*4, intent(out) :: bsol(0:Nm1)
      integer*4, intent(out) :: info

      real*8    chi_min_glob
      integer*4 bbst(0:Nm1)

 400  format(a12,i5,a3,es12.2)
      write(*,*) 'CombSolver: Depth | Minimum chi at this Depth'

      SolFound     = .false.
      chi_min_glob = gig
      chi_min      = gig
      depth        = 0

      if(.not.allocated(btst)) allocate(btst(0:Nm1))
      if(.not.allocated(bmin)) allocate(bmin(0:Nm1))
      if(.not.allocated(z))    allocate(z(1:L))

      btst = bing
      call check_btst()
      if(chi_min .lt. chi_min_glob) then
         chi_min_glob = chi_min
         bbst         = bmin
      end if

      write(*,400) 'CombSolver:', depth, '  | ', sngl(chi_min)

      if(SolFound) then
         bsol = btst
         info = 0
         return
      end if

      if(.not.allocated(p0)) allocate(p0(1:N0))
      if(.not.allocated(p1)) allocate(p1(1:N1))

      call make_index(bing,p0,p1)

      do 1, depth=1,depth_max

      N0d     = N0 - depth
      N1d     = N1 - depth
      chi_min = gig
      btst    = bing

      call next_1(0,0)

      if(chi_min .lt. chi_min_glob) then
         chi_min_glob = chi_min
         bbst         = bmin
      end if

      write(*,400) 'CombSolver:', depth, '  | ', sngl(chi_min)

      if(SolFound) then
         bsol = btst
         info = 0
         return
      end if

 1    continue

      bsol = bbst
      info = 1
      return

      end
