!DIR$ FIXEDFORMLINESIZE:132
      subroutine make_mod(ind, prob, bmod, info)
      use blocks
      use formats
      implicit none

      integer*4, intent(in)  :: ind
      real*8   , intent(in)  :: prob
      integer*4, intent(out) :: bmod(0:Nm1)
      integer*4, intent(out) :: info

      real*8    rnum
      integer*4 x(0:Nm1)
      integer*4 i, i0, i1, j, k, Nbits, irun

      info = 0
      x = 0


      IF(ind .eq. 1) THEN

         open(unit=70, file='mod.dat', status='old', err=1000)

         I  = 0
         I0 = 0
         I1 = 0

 1       continue

         read(70, *, err=1001, end=2) k, j
         I = I + 1
         if(I .ne. k) then
            write(6,f5) '> "mod.dat" has incorrect 1st entry K=', K, ' in line I=', I
            info = I
            return
         end if

         if      (j .eq. 0) then
            I0 = I0 + 1
         else if (j .eq. 1) then
            I1 = I1 + 1
         else
            write(6,f5) '> "mod.dat" has incorrect 2nd entry J=', J, ' in line I=', I
            info = I
            return
         end if

         goto 1
 2       continue
         close(unit=70)

         if(I0+I1 .ne. I) then
            write(6,f1) '> Unexpected error in make_mod: I0+I1=/=I; exiting'
            info = -1
            return
         end if
         
         if(I .ne. N) then
            write(6,f5) '> Number of lines in "mod.dat" I is =/=N; I=', I, ', N=', N
            info = -2
            return
         end if
         
         N1 = I1
         N0 = I0

         open(unit=70, file='mod.dat', status='old',err=1000)
         do 3, i=0,Nm1
         read(70,*,end=1001,err=1001) k, j
         x(i) = j
 3       continue
         close(unit=70)

      ELSE IF(ind .eq. 2) THEN

         Nbits = 0
 7       continue
         call random_number(rnum)
         j = N*rnum
         if(x(j) .eq. 1) goto 7
         x(j) = 1
         Nbits = Nbits + 1
         if(Nbits .lt. N1) goto 7

      ELSE IF(ind .eq. 3) THEN

         irun = 0
 9       continue
         irun = irun + 1
         Nbits = 0
         do 8, i=0,Nm1
         call random_number(rnum)
         if(rnum .gt. prob) goto 8
         Nbits = Nbits + 1
         x(i) = 1
 8       continue
         N1 = Nbits
         N0 = N-N1
         if(N1 .gt. M) then
            write(6,f3) '> Warning: ind=3 resulted in r>M on attempt', irun, ' ; will retry... '
            x = 0
            goto 9
         end if
         
      END IF

      bmod = x
      return

 1000 continue
      write(6,f1) '> File "mod.dat" can not be open; exiting'
      info = 1000
      return

 1001 continue
      write(6,f1) '> Error reading file "mod.dat"; exiting'
      info = 1001
      return

      end
      
